/****************************************************************************************************/
/* QuaBEx Quadruple Browser Extension Framework                                                     */
/* Contents, Popup, Options 側ライブラリ                                                            */
/*      Copyright (c) 2012 by FAR/RAKUDA All Rights Reserved                                        */
/*      Original Namespace : LinkRedirector                                                         */
/****************************************************************************************************/

var _window   = window;
var _document = document;
var WHO = WHO || {};

	/**************************************************************************************/

	WHO.extension = WHO.extension || {};
	WHO.extension.isBackground = false;

	/**************************************************************************************/
	/* Opera, Chrome / Options */

	if((window.opera&&opera.extension.bgProcess)||(window.chrome&&chrome.extension.getURL("") == window.location.protocol+"//"+window.location.host+"/"))
	{
		//------------------------------------------------------------------------------------//
		/* 設定ページの初期化 */
		//Options

		WHO.extension.initializeOptions = function()
		{
			/* ツールバーボタンの表示切り替え設定 */
			document.addEventListener('DOMContentLoaded',function(e)
			{
				var buttonConfig = JSON.parse(WHO.extension.storage.getItem('buttonConfig'))||{view:true};
				var div = document.createElement('div');
					div.style.display      = "block";
					div.style.position     = "fixed";
					div.style.zIndex       = "65535";
					div.style.bottom       = "auto"
					div.style.left         = "auto";
					div.style.right        = "2px";
					div.style.top          = "2px";
					div.style.background   = "#cccccc";
					div.style.borderWidth  = "0";
					div.style.padding      = "4px";
					div.style.borderRadius = "4px"
					div.style.height       = "16px;"
					div.style.lineHeight   = "0px;"
					
				var input = document.createElement('input');
				//	input.style.WebkitAppearance = "initial";
					input.style.display  = "block";
					input.style.border   = "2px solid #ffffff";
					input.style.width    = "16px";
					input.style.height   = "16px";
					input.style.margin   = "0";
					input.style.verticalAlign = "middle";
					input.setAttribute('type',"checkbox");
					input.setAttribute('title',"Toolbar Button");
					input.checked = buttonConfig.view;
					input.addEventListener('change',function(e)
					{
						WHO.extension.sendRequest("ButtonConfig",{method:"set",view:this.checked});
					},false);
					div.appendChild(input);
				document.documentElement.appendChild(div);
			},false);
		};

		/* ページリフレッシュ */

		WHO.extension.refreshOptions = function()
		{
			window.location.reload();
		};
	}

	/**************************************************************************************/

	/*  #####  #####  ###### #####    ###   */
	/* #     # #    # #      #    #  #   #  */
	/* #     # #    # #      #    # #     # */
	/* #     # #    # #####  #    # ####### */
	/* #     # #####  #      #####  #     # */
	/* #     # #      #      #  #   #     # */
	/*  #####  #      ###### #   ## #     # */

	if(window.opera)
	{
		WHO.extension.isOpera = true;

		/**************************************************************************************/
		/* Popup */

		if(opera.extension.bgProcess)
		{

			//------------------------------------------------------------------------------------//
			/* ストレージ */

			WHO.extension.storage = widget.preferences;

			//------------------------------------------------------------------------------------//
			/* background への参照 */

			WHO.extension.getBackground = function()
			{
				return opera.extension.bgProcess;
			};

			//------------------------------------------------------------------------------------//
			/* ポップアップの初期化 */

			WHO.extension.initializePopup = function(){}

			/* ポップアップページのスタートアップ */

			WHO.extension.addShowListener = function(listener)
			{
				document.addEventListener('DOMContentLoaded',listener,false);
			}
		}

		/**************************************************************************************/

		//------------------------------------------------------------------------------------//
		/* メッセージ送信 */

		WHO.extension.postMessage = function(type,message)
		{
			opera.extension.postMessage({"messageType":"message",type:type,message:message});
		};

		/* メッセージ取得を追加 */

		WHO.extension.addMessageListener = function(type,listener)
		{
			listener.messageListener = listener.messageListener||{};
			if(listener.messageListener[type])
			{
				return;
			}
			listener.messageListener[type] = function(e)
			{
				var data         = e.data;

				if(data.messageType == "message" && data.type == type)
				{
					listener(data.message);
				}
			}
			opera.extension.addEventListener('message',listener.messageListener[type],false);
		};

		/* メッセージ取得を削除 */

		WHO.extension.removeMessageListener = function(type,listener)
		{
			listener.messageListener = listener.messageListener||{};
			opera.extension.removeEventListener('message',listener.messageListener[type],false);
			delete listener.messageListener[type];
		};

		//------------------------------------------------------------------------------------//
		/* リクエスト送信 */
		// type     : メッセージタイプ
		// message  : 送信メッセージデータ
		// callback : メッセージ返信受信時のコールバック メッセージデータを引数として受け取る

		WHO.extension._requestID = 0;
		WHO.extension.sendRequest = function(type,message,callback)
		{
			var data =
			{
				messageType : "request",
				type        : type,
				message     : message,
			};
			if(callback)
			{
				var requestID  = ++WHO.extension._requestID;
				data.requestID = requestID;
				opera.extension.addEventListener('message',function(e)
				{
					var data = e.data;
					if(data.messageType == "response" && data.type == type && data.responseID == requestID)
					{
						opera.extension.removeEventListener('message',arguments.callee,false);
						callback(data.message);
					}
				},false);
			}
			opera.extension.postMessage(data);
		};

		/* リクエスト受信 */

		WHO.extension.addRequestListener = function(type,listener)
		{
			listener.requestListener = listener.requestListener||{};
			if(listener.requestListener[type])
			{
				return;
			}
			listener.requestListener[type] = function(e)
			{
				var data = e.data;

				if(data.messageType == "request" && data.type == type)
				{
					var sender =
					{
						source          : e.source,
						messageCallback : function(){}
					};

					if(data.requestID)
					{
						sender.messageCallback = function(message)
						{
							sender.source.postMessage(
							{
								messageType:"response",
								type       :data.type,
								responseID :data.requestID,
								message    :message
							});
						};
					}

					listener(sender,data.message);
				}
			};
			opera.extension.addEventListener('message',listener.requestListener[type],false);
		};

		/* リクエスト受信を削除 */

		WHO.extension.removeRequestListener = function(type,listener)
		{
			listener.requestListener = listener.requestListener||{};
			opera.extension.removeEventListener('message',listener.requestListener[type],false);
			delete listener.requestListener[type];
		};

	//	//------------------------------------------------------------------------------------//
	//	/* エクステンション連携 */
	//	// message  : 送信メッセージデータ
	//	// callback : メッセージ返信受信時のコールバック メッセージデータを引数として受け取る
	//	WHO.extension._externalRequestID = 0;
	//	WHO.extension.extensionID       = widget.id;
	//	WHO.extension.sendRequestExternal = function(type,message,callback)
	//	{
	//		var data =
	//		{
	//			messageType : "request",
	//			extensionID : WHO.extension.extensionID,
	//			type        : type,
	//			message     : message,
	//		};
	//		if(callback)
	//		{
	//			var requestID  = ++WHO.extension._externalRequestID;
	//			data.requestID = requestID;
	//			window.addEventListener('message',(function(requestID){return function(e)
	//			{
	//				var data = e.data;
	//				if(typeof data == "object" && data.extensionID == WHO.extension.extensionID && data.messageType == "response" && data.type == type && data.responseID == requestID)
	//				{
	//					window.removeEventListener('message',arguments.callee,false);
	//					callback(data.message);
	//				}
	//			}})(requestID),false);
	//		}
	//		window.postMessage(data,"*");
	//	};
	//
	//	/* エクステンション連携受信 */
	//
	//	WHO.extension.addExternalRequestListener = function(type,listener)
	//	{
	//		listener.externalRequestListener = listener.externalRequestListener||{};
	//		if(listener.externalRequestListener[type])
	//		{
	//			return;
	//		}
	//		listener.externalRequestListener[type] = function(e)
	//		{
	//			var data = e.data;
	//
	//			if(typeof data == "object" && (data.messageType == "message"||data.messageType == "request") && data.type == type)
	//			{
	//				var sender =
	//				{
	//					source          : e.source,
	//					messageCallback : function(){}
	//				};
	//
	//				if(data.messageType == "request")
	//				{
	//					sender.messageCallback = function(message)
	//					{
	//						sender.source.postMessage(
	//						{
	//							extensionID:data.extensionID,
	//							messageType:"response",
	//							type       :data.type,
	//							responseID :data.requestID,
	//							message    :message
	//						},"*");
	//					};
	//				}
	//
	//				listener(sender,data.message);
	//			}
	//		};
	//		window.addEventListener('message',listener.externalRequestListener[type],false);
	//	};
	//
	//	/* エクステンション連携受信を削除 */
	//
	//	WHO.extension.removeExternalRequestListener = function(type,listener)
	//	{
	//		listener.externalRequestListener = listener.externalRequestListener||{};
	//		opera.extension.removeEventListener('message',listener.externalRequestListener[type],false);
	//		delete listener.externalRequestListener[type];
	//	};

	}
	else

	/**************************************************************************************/

	/*  #####  #     # #####   #####  #     # ######  */
	/* #     # #     # #    # #     # ##   ## #       */
	/* #       #     # #    # #     # # # # # #       */
	/* #       ####### #    # #     # #  #  # #####   */
	/* #       #     # #####  #     # #     # #       */
	/* #     # #     # #  #   #     # #     # #       */
	/*  #####  #     # #   ##  #####  #     # ######  */

	if(window.chrome)
	{

		WHO.extension.isChrome = true;

		//------------------------------------------------------------------------------------//
		/* ストレージ */

		WHO.extension.storage = window.localStorage;

		/**************************************************************************************/
		/* Popup, Options */

		if(chrome.extension.getURL("") == window.location.protocol+"//"+window.location.host+"/")
		{

			//------------------------------------------------------------------------------------//
			/* Background への参照 */

			WHO.extension.getBackground = function()
			{
				return chrome.extension.getBackgroundPage();
			};

			//------------------------------------------------------------------------------------//
			/* ポップアップのサイズを調整 */

			//Popup 側
			WHO.extension.getPopupSize = function()
			{
				return WHO.extension.getBackground().WHO.extension.popupSize;
			};
			/* ポップアップの初期化 */

			WHO.extension.initializePopup = function()
			{
				WHO.extension.postMessage("OpenPopup",{url:window.location.href});
				document.addEventListener('DOMContentLoaded',function()
				{
					var size = WHO.extension.getPopupSize();

					document.documentElement.style.width  = size.width  + "px";
					document.documentElement.style.height = size.height + "px";
				},false);
			};

			/* ポップアップページのスタートアップ */

			WHO.extension.addShowListener = function(listener)
			{
				document.addEventListener('DOMContentLoaded',listener,false);
			}
		}

		/**************************************************************************************/

		//------------------------------------------------------------------------------------//

		WHO.extension._port = chrome.extension.connect({name:"connect"});

		/* メッセージ送信 */

		WHO.extension.postMessage = function(type,message)
		{
			WHO.extension._port.postMessage({type:type,message:message});
		};

		/* メッセージ取得を追加 */

		WHO.extension.addMessageListener = function(type,listener)
		{
			listener.messageListener = listener.messageListener||{};
			if(listener.messageListener[type])
			{
				return;
			}
			listener.messageListener[type] = function(data)
			{
				if(data.type == type)
				{
					listener(data.message);
				}
			}
			WHO.extension._port.onMessage.addListener(listener.messageListener[type]);
		};

		/* メッセージ取得を削除 */

		WHO.extension.removeMessageListener = function(type,listener)
		{
			listener.messageListener = listener.messageListener||{};
			WHO.extension._port.onMessage.removeListener(listener.messageListener[type]);
			delete listener.messageListener[type];
		};

		//------------------------------------------------------------------------------------//
		/* リクエスト送信 */
		// Contents, Popup -> Background

		WHO.extension.sendRequest = function(type,message,callback)
		{
			if(callback)
			{
				chrome.extension.sendRequest({type:type,message:message},callback);
			}
			else
			{
				chrome.extension.sendRequest({type:type,message:message});
			}
		};

		/* リクエスト受信 */

		WHO.extension.addRequestListener = function(type,listener)
		{
			chrome.extension.onRequest.addListener(function(data,sender,messageCallback)
			{
				if(data.type == type)
				{
					var sender =
					{
						source         :sender,
						messageCallback:messageCallback,
					};
					listener(sender,data.message);
				}
			});
		};

		//------------------------------------------------------------------------------------//
		/* エクステンション連携 */
		// type     : エクステンション名
		// message  : 送信メッセージデータ
		// callback : メッセージ返信受信時のコールバック メッセージデータを引数として受け取る

		WHO.extension._extensionID =
		{
		//	"LinkFilterAPI" : "fdaokadpgpmmekabpbgfcoehpjnhgfif",
			"LinkFilterAPI" : "denfknfcphmmieahniodneijpnhcgped",
		//	"LinkFilterAPI" : "oabijoalajplcmdechobhijblbhpniok",
		};
		WHO.extension.sendRequestExternal = function(type,message,callback)
		{
			var extensionID = WHO.extension._extensionID[type];
			if(callback)
			{
				chrome.extension.sendRequest(extensionID,{type:type,message:message},callback);
			}
			else
			{
				chrome.extension.sendRequest(extensionID,{type:type,message:message});
			}
		};

		/*******************************************************************************/
	}
	else

	/**************************************************************************************/

	/*  #####    ###   ######   ###   #####  ### */
	/* #     #  #   #  #       #   #  #    #  #  */
	/* #       #     # #      #     # #    #  #  */
	/*  #####  ####### #####  ####### #    #  #  */
	/*       # #     # #      #     # #####   #  */
	/* #     # #     # #      #     # #  #    #  */
	/*  #####  #     # #      #     # #   ## ### */

	if(window.safari)
	{
		WHO.extension.isSafari = true;
		WHO.extension._pageID = parseInt(Math.random() * 65536);

		//------------------------------------------------------------------------------------//
		/* ポップアップページのスタートアップ */

		WHO.extension.addShowListener = function(listener)
		{
			if(safari.application)
			{
				safari.application.addEventListener('popover',listener,false);
			}
			else
			{
				document.addEventListener('DOMContentLoaded',listener,false);
			}
		}

		/**************************************************************************************/
		/* Popup */

		if(safari.extension.globalPage)
		{

			//------------------------------------------------------------------------------------//
			/* ストレージ */

			WHO.extension.storage = window.localStorage;

			//------------------------------------------------------------------------------------//
			/* background への参照 */

			WHO.extension.getBackground = function()
			{
				return safari.extension.globalPage.contentWindow;
			};

			//------------------------------------------------------------------------------------//

			WHO.extension.initializePopup = function()
			{
				/* 設定ページへのリンク設定 */
				document.addEventListener('DOMContentLoaded',function(e)
				{
					var links = document.querySelectorAll('a[href^="options.html"]');
					for(var i = 0,link;link = links[i];i++)
					{
						var href = link.getAttribute('href');
						link.onclick = (function(href){return function(e)
						{
							var newTab    = WHO.extension.getBackground().safari.application.activeBrowserWindow.openTab();
								newTab.url= WHO.extension.getBackground().safari.extension.baseURI+"data/" + href;
							e.preventDefault();
							return false;
						}})(href);
					}
				},false);
			}

			/**************************************************************************************/

			//------------------------------------------------------------------------------------//
			/* メッセージ送信 */

			WHO.extension.postMessage = function(type,message)
			{
				safari.extension.globalPage.contentWindow.postMessage({messageType:"message",type:type,message:message},"*");
			};

			/* メッセージ取得を追加 */
			// Background -> Popup

			WHO.extension.addMessageListener = function(type,listener)
			{
				listener.messageListener = listener.messageListener||{};
				if(listener.messageListener[type])
				{
					return;
				}
				listener.messageListener[type] = function(e)
				{
					var data   = e.data;

					if(data.messageType == "message" && data.type == type)
					{
						listener(data.message);
					}
				}
				window.addEventListener('message',listener.messageListener[type],false);
			};

			/* メッセージ取得を削除 */

			WHO.extension.removeMessageListener = function(type,listener)
			{
				listener.messageListener = listener.messageListener||{};
				window.removeEventListener('message',listener.messageListener[type],false);
				delete listener.messageListener[type];
			};

			//------------------------------------------------------------------------------------//
			/* リクエスト送信 */

			WHO.extension._requestID = 0;
			WHO.extension.sendRequest = function(type,message,callback)
			{
				var data =
				{
					messageType : "request",
					type        : type,
					message     : message,
				};
				if(callback)
				{
					var requestID  = ++WHO.extension._requestID;
					data.requestID = requestID;
					window.addEventListener('message',function(e)
					{
						var data = e.data;
						if(data.messageType == "response" && data.type == type && data.responseID == requestID)
						{
							window.removeEventListener('message',arguments.callee,false);
							callback(data.message);
						}
					},false);
				}
				safari.extension.globalPage.contentWindow.postMessage(data,"*");
			};

		}

		/**************************************************************************************/
		/* Contents, Options */

		else
		{

			//------------------------------------------------------------------------------------//
			/* ストレージ */

			WHO.extension.storage =
			{
				setItem    : function(key,value)
				{
					safari.self.tab.dispatchMessage("localStorage",{method:"setItem",key:key,value:value});
					return window.localStorage.setItem(key,value);
				},
				getItem    : function(key)
				{
					return window.localStorage.getItem(key);
				},
				removeItem : function(key)
				{
					safari.self.tab.dispatchMessage("localStorage",{method:"removeItem",key:key});
					return window.localStorage.removeItem(key);
				}
			};

			//------------------------------------------------------------------------------------//
			/* 設定ページの初期化 */

			WHO.extension.initializeOptions = function(){};

			/**************************************************************************************/

			//------------------------------------------------------------------------------------//
			/* メッセージ送信 */

			WHO.extension.postMessage = function(type,message)
			{
				safari.self.tab.dispatchMessage("message",{type:type,pageID:WHO.extension._pageID,message:message});
			};

			/* メッセージ取得を追加 */
			// Background -> Contents, Options

			WHO.extension.addMessageListener = function(type,listener)
			{
				listener.messageListener = listener.messageListener||{};
				if(listener.messageListener[type])
				{
					return;
				}
				listener.messageListener[type] = function(e)
				{
					var data   = e.message;

					if(e.name == "message" && data.type == type && data.pageID == WHO.extension._pageID)
					{
						listener(data.message);
					}
				}
				safari.self.addEventListener('message',listener.messageListener[type],false);
			};

			/* メッセージ取得を削除 */

			WHO.extension.removeMessageListener = function(type,listener)
			{
				listener.messageListener = listener.messageListener||{};
				safari.self.removeEventListener('message',listener.messageListener[type],false);
				delete listener.messageListener[type];
			};

			//------------------------------------------------------------------------------------//
			/* リクエスト送信 */

			WHO.extension._requestID = 0;
			WHO.extension.sendRequest = function(type,message,callback)
			{
				var data =
				{
					type   :type,
					message:message,
					pageID :WHO.extension._pageID
				};
				if(callback)
				{
					var requestID  = ++WHO.extension._requestID;
					data.requestID = requestID;
					safari.self.addEventListener('message',function(e)
					{
						var data = e.message;
						if(e.name == "response" && data.type == type && data.responseID == requestID && data.pageID == WHO.extension._pageID)
						{
							safari.self.removeEventListener('message',arguments.callee,false);
							callback(data.message);
						}
					},false);
				}
				safari.self.tab.dispatchMessage("request",data);
			};

//			/* リクエスト受信 */
//		
//			WHO.extension.addRequestListener = function(type,listener)
//			{
//				listener.requestListener = listener.requestListener||{};
//				if(listener.requestListener[type])
//				{
//					return;
//				}
//				listener.requestListener[type] = function(e)
//				{
//					var data = e.message;
//		
//					if(e.name == "request" && data.type == type)
//					{
//						var sender =
//						{
//							source          : e.target.page,
//							messageCallback : function(){}
//						}
//		
//						if(data.requestID)
//						{
//							sender.messageCallback = function(message)
//							{
//								sender.source.dispatchMessage("response",
//								{
//									type      :data.type,
//									responseID:data.requestID,
//									message   :message
//								});
//							};
//						}
//		
//						listener(sender,data.message);
//					}
//				}
//				safari.self.addEventListener('message',listener.requestListener[type],false);
//			};
//		
//			/* リクエスト受信を削除 */
//		
//			WHO.extension.removeRequestListener = function(type,listener)
//			{
//				listener.requestListener = listener.requestListener||{};
//				safari.self.removeEventListener('message',listener.requestListener[type],false);
//				delete listener.requestListener[type];
//			};

			//------------------------------------------------------------------------------------//
			/* エクステンション連携 */
			// message  : 送信メッセージデータ
			// callback : メッセージ返信受信時のコールバック メッセージデータを引数として受け取る
			WHO.extension._externalRequestID = 0;
			WHO.extension.extensionID = safari.extension.baseURI;
			WHO.extension.sendRequestExternal = function(type,message,callback)
			{
				var data =
				{
					messageType : "request",
					extensionID : WHO.extension.extensionID,
					type        : type,
					message     : message,
					pageID      : WHO.extension._pageID
				};
				if(callback)
				{
					var requestID  = ++WHO.extension._externalRequestID;
					data.requestID = requestID;
					window.addEventListener('message',(function(requestID){return function(e)
					{
						var data = e.data;
						if(typeof data == "object" && data.extensionID == WHO.extension.extensionID && data.messageType == "response" && data.type == type && data.responseID == requestID && data.pageID == WHO.extension._pageID)
						{
							window.removeEventListener('message',arguments.callee,false);
							callback(data.message);
						}
					}})(requestID),false);
				}
				window.postMessage(data,"*");
			};

			/* エクステンション連携受信 */

			WHO.extension.addExternalRequestListener = function(type,listener)
			{
				listener.externalRequestListener = listener.externalRequestListener||{};
				if(listener.externalRequestListener[type])
				{
					return;
				}
				listener.externalRequestListener[type] = function(e)
				{
					var data = e.data;

					if(typeof data == "object" && data.messageType == "request" && data.type == type)
					{
						var sender =
						{
							source          : e.source,
							messageCallback : function(){}
						};

						if(data.messageType == "request")
						{
							sender.messageCallback = function(message)
							{
								sender.source.postMessage(
								{
									extensionID:data.extensionID,
									messageType:"response",
									type       :data.type,
									responseID :data.requestID,
									 pageID    :data.pageID,
									message    :message
								},"*");
							};
						}

						listener(sender,data.message);
					}
				};
				window.addEventListener('message',listener.externalRequestListener[type],false);
			};

			/* エクステンション連携受信を削除 */

			WHO.extension.removeExternalRequestListener = function(type,listener)
			{
				listener.externalRequestListener = listener.externalRequestListener||{};
				opera.extension.removeEventListener('message',listener.externalRequestListener[type],false);
				delete listener.externalRequestListener[type];
			};
		}

		/**************************************************************************************/
	}
	else

	/**************************************************************************************/

	/* ###### ### #####  ###### ######  #####  #     # */
	/* #       #  #    # #      #      #     #  #   #  */
	/* #       #  #    # #      #      #     #   # #   */
	/* #####   #  #    # #####  #####  #     #    #    */
	/* #       #  #####  #      #      #     #   # #   */
	/* #       #  #  #   #      #      #     #  #   #  */
	/* #      ### #   ## ###### #       #####  #     # */
	// Only for Panel Content Script

	if(window.unsafeWindow)
	{
		var _window   = window.unsafeWindow||window;
		var _document = _window.document;

		WHO.extension.isJetpack = true;

		/**************************************************************************************/
		/* Options, Popup */

		if(/^resource:\/\//i.test(window.location.href))
		{

			//------------------------------------------------------------------------------------//
			/* ストレージ */

			WHO.extension._localStorage = {};
			WHO.extension.storage = 
			{
				setItem : function(key,value)
				{
					WHO.extension._localStorage[key] = value;
					self.port.emit('setItem',{key:key,value:value});
				},
				getItem : function(key)
				{
					return WHO.extension._localStorage[key]||null;
				},
				removeItem : function(key)
				{
					WHO.extension._localStorage[key] = null;
					self.port.emit('removeItem',{key:key,value:value});
				}
			};

			//------------------------------------------------------------------------------------//
			/* background への参照 */
			//Firefox では直接参照は出来ない

			WHO.extension._background = {};
			WHO.extension.getBackground = function()
			{
				return WHO.extension._background;
			};

			//------------------------------------------------------------------------------------//
			/* ポップアップページの初期化 */

			WHO.extension.initializePopup = function()
			{
				self.port.on('storage',function(localStorage)
				{
					//ストレージのコピー
					WHO.extension._localStorage = localStorage;
				});
				/* 設定ページへのリンク設定 */
				document.addEventListener('DOMContentLoaded',function(e)
				{
					var links = document.querySelectorAll('a[href^="options.html"]');
					for(var i = 0,link;link = links[i];i++)
					{
						var hash = link.getAttribute('href').match(/#.*/i);
						link.onclick = (function(hash){return function(e)
						{
							self.port.emit("options",{hash:hash});
							e.preventDefault();
							return false;
						}})(hash);
					}
				},false);
			};

			/* 設定ページの初期化 */

			WHO.extension.initializeOptions = function()
			{
				self.port.on('storage',function(localStorage)
				{
					//ストレージのコピー
					WHO.extension._localStorage = localStorage;
				});
				self.port.on('open',function(message)
				{
					window.location.hash = message.hash;
				});
			};

			WHO.extension.refreshOptions = function()
			{
				self.port.emit('hide',{show:true});
			};

			/* ポップアップページのスタートアップ */

			WHO.extension.addShowListener = function(listener)
			{
				self.port.on('show',function(e)
				{
					listener();
				});
			};

		}

		/**************************************************************************************/

		//------------------------------------------------------------------------------------//
		/* メッセージ送信 */

		WHO.extension.postMessage = function(type,message)
		{
			self.port.emit('message',{type:type,message:message});
		};

		/* メッセージ取得を追加 */

		WHO.extension.addMessageListener = function(type,listener)
		{
			listener.messageListener = listener.messageListener||{};
			if(listener.messageListener[type])
			{
				return;
			}
			listener.messageListener[type] = function(data)
			{
				if(data.type == type)
				{
					listener(data.message);
				}
			}
			self.port.on('message',listener.messageListener[type]);
		};

		/* メッセージ取得を削除 */

		WHO.extension.removeMessageListener = function(type,listener)
		{
			listener.messageListener = listener.messageListener||{};
			self.port.removeListener('message',listener.messageListener[type]);
			delete listener.messageListener[type];
		};

		//------------------------------------------------------------------------------------//
		/* リクエスト送信 */

		WHO.extension._requestID = 0;
		WHO.extension.sendRequest = function(type,message,callback)
		{
			var data =
			{
				type       :type,
				message    :message,
			};
			if(callback)
			{
				var requestID  = ++WHO.extension._requestID;
				data.requestID = requestID;
				self.port.on('response',function(data)
				{
					if(data.type == type && data.responseID == requestID)
					{
						self.port.removeListener('response',arguments.callee);
						callback(data.message);
					}
				},false);
			}
			self.port.emit('request',data);
		};

		/* リクエスト受信 */

		WHO.extension.addRequestListener = function(type,listener)
		{
			listener.requestListener = listener.requestListener||{};
			if(listener.requestListener[type])
			{
				return;
			}
			listener.requestListener[type] = function(data)
			{
				if(data.type == type)
				{
					var sender =
					{
						source          : self,
						messageCallback : function(){}
					};

					if(data.requestID)
					{
						sender.messageCallback = function(message)
						{
							sender.source.port.emit('response',
							{
								type       :data.type,
								responseID :data.requestID,
								message    :message
							});
						};
					}

					listener(sender,data.message);
				}
			};
			self.port.on('request',listener.requestListener[type]);
		};

		/* 単発メッセージ受信を削除 */

		WHO.extension.removeRequestListener = function(type,listener)
		{
			listener.requestListener = listener.requestListener||{};
			self.port.removeListener('request',listener.requestListener[type]);
			delete listener.requestListener[type];
		};

		/**************************************************************************************/

	}
	else
	{
		WHO.extension.storage           = {setItem:function(){},getItem:function(){return null;}};
		WHO.extension.initializeOptions = function(){};
		WHO.extension.addShowListener   = function(){};
	}

