/****************************************************************************************************/
/* Extension UI 生成 ライブラリ                                                                     */
/*      Copyright (c) 2012 by FAR/RAKUDA All Rights Reserved                                        */
/*      Original Namespace : LinkRedirector                                                         */
/****************************************************************************************************/

var WHO = WHO || {};

	/**************************************************************************************/

	WHO.background = function(para)
	{
		var self = this;

		WHO.extension.storage.setItem('extensionName',para.extensionName);

		this.extensionName = para.extensionName;

		//------------------------------------------------------------------------------------//
		/* サイト別設定の適用範囲 */

		// full protocol://domain:port/pathname?query 
		if(para.originType == "full")
		{
			this.originReg = /^.*$/i;
		}
		else
		// page protocol://domain:port/pathname ページレベルで区別
		if(para.originType == "page")
		{
			this.originReg = /^[^\#\?]+/i;
		}
		else
		// port protocol://domain:port/ ポート番号レベルで区別
		if(para.originType == "port")
		{
			this.originReg = /^https?:\/\/[^\/:]+(?:\:\d*)?\//i;
		}
		else
		// protocol protocol://domain プロトコルレベルで区別
		if(para.originType == "protocol")
		{
			this.originReg = /^https?:\/\/[^\/:]+/i;
		}
		else
		// domain domain ドメイン名のみで区別
	//	if(para.originType == "domain")
		{
			this.originReg = /(?!^https?:\/\/)\b[^\/:]+\b/i;
		}

		//------------------------------------------------------------------------------------//
		/* アクティブページ */

		this.focused =
		{
			source      : null,
			tab         : null,
			url         : "",
			origin      : "",
			status      : {},
		//	postMessage : function(){console.log("")}
		};

		//アクティブページが切りかわった時のコールバック
		this.focusedCallback = para.focusedCallback || function(source,origin,message){};
		this.clearedCallback = para.clearedCallback || function(){};
		this.focusedIsLock   = false;

		//------------------------------------------------------------------------------------//
		/* ボタン・バッヂ・ポップアップの作成 */

		para.button=para.button||{};

		this.defaultButton =
		{
			title : para.button.title || "Disabled",
			icon  : para.button.icon  || "icons/icon18.png"
		}

		//Chrome でポップアップのサイズを調整するため
		if(para.popup)
		{
			WHO.extension.setPopupSize(para.popup.width  || 320,para.popup.height || 500);
		}

		if(WHO.extension.isOpera)
		{
			var _button =
			{
				disabled : true,
				title    : this.defaultButton.title,
				icon     : this.defaultButton.icon,
				onclick  : para.onclick || null,
			};
			if(para.popup)
			{
				_button.popup =
				{
					href  : para.popup.href   || "popup.html",
					width : (para.popup.width  || 320) + "px",
					height: (para.popup.height || 500) + "px"
				};
			}
			if(para.badge)
			{
				_button.badge =
				{
					display        : para.badge.display         || "none",
					backgroundColor: para.badge.backgroundColor || "#cc0000",
					color          : para.badge.color           || "#ffffff",
					textContent    : para.badge.textContent     || "-",
		    	};
			}
			this.button = opera.contexts.toolbar.createItem(_button);
			this._popup = this.button.popup;
			this.badge  = this.button.badge;
			/* Popup の取得 */
			if(this._popup)
			{
				opera.extension.addEventListener('connect',function(e)
				{
					if(e.origin == self._popup.href)
					{
						self.popup =
						{
							source      : e.source,
							tab         : {url:e.origin},//Opera では接続ポートからタブを取得できない,
							url         : e.origin,
							postMessage : function(type,message)
							{
								e.source.postMessage(
								{
									messageType:"message",
									type       :type,
									message    :message
								});
							}
						};
					}
				},false);
				opera.extension.addEventListener('disconnect',function(e)
				{
					if(e.origin == self._popup.href)
					{
						self.popup = null;
					}
				},false);
			}
		}
		else
		if(WHO.extension.isChrome)
		{
			if(para.badge)
			{
				this.button = chrome.browserAction;
				this.badge  = para.badge;
				this.updateButton(this.defaultButton);
			}
			else
			{
				this.button = chrome.pageAction;
			}
			if(para.onclick)
			{
				this.button.onClicked.addListener(para.onclick);
			}
			/* Popup の取得 */
			WHO.extension.addMessageListener('OpenPopup',function(port,message)
			{
				self.popup =
				{
					source      : port.source,
					tab         : port.tab,
					url         : message.url,
					postMessage : port.postMessage,
				};

				port.source.onDisconnect.addListener(function()
				{
					port.source.onDisconnect.removeListener(arguments.callee);
					self.popup = null;
				});
			});
		}
		else
		if(WHO.extension.isSafari)
		{
			this.button = safari.extension.toolbarItems[0];
			this.updateButton(this.defaultButton);
			/* Popup の取得 */
			if(para.popup)
			{
				var source = this.button.popover.contentWindow;
				this.popup =
				{
					source      : source,
					tab         : source,
					url         : source.location.href,
					postMessage : function(type,message)
					{
						source.postMessage(
						{
							messageType : "message",
							type        : type,
							message     : message
						},source.location.href);
					}
				}
				safari.extension.popovers[0].width  = (para.popup.width  || 320);
				safari.extension.popovers[0].height = (para.popup.height || 500);
			}
		}

		/* ボタンの表示切り替え */
		this.toggleButton();//起動時

		//------------------------------------------------------------------------------------//
		/* タブ移動やページ移動時の初期化処理 */

		/* ページにフォーカスした時 */
		//現在のフォーカスページを登録
		WHO.extension.addMessageListener('FocusedPage',function(port,message)
		{
			if(message.method == "set")
			{
				if(message.focused || WHO.extension.isFocusedTab(port.tab))
				{
					self.setFocused(port,message);
				}
			}
		});
		/* ポップアップにアクティブページの情報を送る */
		WHO.extension.addRequestListener('FocusedPage',function(sender,message)
		{
			if(message.method == "get")
			{
				if(self.focused.source)
				{
					sender.messageCallback({method:"set",focused:{url:self.focused.url,origin:self.focused.origin,status:self.focused.status}});
				}
			}
		});

		/* ボタンの表示設定の切り替え */
			//オプションから
		WHO.extension.addRequestListener('ButtonConfig',function(sender,message)
		{
			if(message.method == "set")
			{
				WHO.extension.storage.setItem('buttonConfig',JSON.stringify({view:message.view}));
				self.toggleButton();
			}
		});

		/* ボタンの初期化 */
		if(window.opera)
		{
			/* ページを開いたとき */
			opera.extension.addEventListener('connect',function(e){},false);
			/* ページが閉じられたとき */
			opera.extension.addEventListener('disconnect',function(e)
			{
				//閉じられたページがフォーカスページの時
				if(e.source == self.focused.source)
				{
					self.clearFocused(e);
				}
			},false);
			/* タブを移動したとき */
			opera.extension.tabs.addEventListener('focus',function(e)
			{
				//ウェブページ以外のタブの時
				//プライベートタブでも発動
				if(!opera.extension.tabs.getFocused())
				{
					self.clearFocused();
				}
			},false);

			//バックグランドの準備が出来たことを通知する
			opera.extension.broadcastMessage({method:"readyBackground"});
		}
		else
		if(window.chrome)
		{
			var urltest = /^https?:\/\//i;
			/* ページが移動したとき */
			chrome.tabs.onUpdated.addListener(function(tabID,info,tab)
			{
				if(WHO.extension.isFocusedTab(tab) && info.url && !urltest.test(info.url))
				{
					self.clearFocused();
				}
			});
			/* タブを移動したとき */
			chrome.tabs.onSelectionChanged.addListener(function(tabID)
			{
				chrome.tabs.get(tabID,function(tab)
				{
					if(!tab||!urltest.test(tab.url))
					{
						self.clearFocused();
					}
				});
			});
		}
		else
		if(window.safari)
		{
			/* ページが閉じられたとき */
			safari.application.addEventListener('close',function(e)
			{
				//閉じられたページがフォーカスページの時
				if(e.target.page == self.focused.source)
				{
					self.clearFocused(e);
				}
			},true);
			/* タブを移動したとき */
			safari.application.addEventListener('activate',function(e)
			{
				if(!e.target.page)
				{
					self.clearFocused(e);
				}
			},true);
		}

		//------------------------------------------------------------------------------------//

		return this;
	};



	/**************************************************************************************/

	//------------------------------------------------------------------------------------//
	/* 設定ページを開く */

	WHO.background.prototype.openOptions = function(hash)
	{
		if(WHO.extension.isOpera)
		{
			opera.extension.tabs.create({url:"options.html" + hash,focused:true});
		}
		else
		if(WHO.extension.isChrome)
		{
			chrome.tabs.create({url:"data/options.html" + hash})
		}
		else
		if(WHO.extension.isSafari)
		{
			var newTab = safari.application.activeBrowserWindow.openTab();
			newTab.url = safari.extension.baseURI+"data/options.html" + hash;
		}
	};

	//------------------------------------------------------------------------------------//
	/* ボタン表示を切り替える */

	WHO.background.prototype.toggleButton = function()
	{
		var buttonConfig = JSON.parse(WHO.extension.storage.getItem('buttonConfig'))||{view:true};
		if(WHO.extension.isOpera)
		{
			if(buttonConfig.view)
			{
				opera.contexts.toolbar.addItem(this.button);
			}
			else
			{
				opera.contexts.toolbar.removeItem(this.button);
			}
		}
		else
		if(WHO.extension.isChrome && this.focused && this.focused.tab)
		{
			if(buttonConfig.view)
			{
				this.button.show(this.focused.tab.id);
			}
			else
			{
				this.button.hide(this.focused.tab.id);
			}
		}
		else
		if(WHO.extension.isSafari)
		{
			//非対応
		}
	};

	/* ボタンを更新する */

	WHO.background.prototype.updateButton = function(para)
	{
		if(window.opera)
		{
			this.button.icon     = para.icon  || this.defaultButton.icon;
			this.button.title    = para.title || this.defaultButton.title;
		}
		else
		if(window.chrome)
		{
			this.button.setIcon({path:para.icon    || this.defaultButton.icon ,tabId:this.focused.tab.id});
			this.button.setTitle({title:para.title || this.defaultButton.title,tabId:this.focused.tab.id})
		}
		else
		if(window.safari)
		{
			this.button.image   = safari.extension.baseURI + "data/" + (para.icon  || this.defaultButton.icon);
			this.button.toolTip = para.title || this.defaultButton.title;
		}
	};

	//------------------------------------------------------------------------------------//
	/* バッジを更新する */

	WHO.background.prototype.updateBadge = function(para)
	{
		if(window.opera)
		{
			this.button.badge.display     = para.display||"none";
			this.button.badge.textContent = para.text||"-";
		}
		else
		if(window.chrome)
		{
			this.button.setBadgeText(para.text||"-");
		}
		else
		if(window.safari)
		{
		}
	};

	/**************************************************************************************/

	//------------------------------------------------------------------------------------//
	/* フォーカスの初期化 */

	WHO.background.prototype.clearFocused = function()
	{
		if(!this.focusedIsLock)
		{
			this.focused =
			{
				source      : null,
				tab         : null,
				url         : "",
				origin      : "",
				status      : {},
			//	postMessage : function(){console.log("")}
			};
			if(this.button)
			{
				this.button.disabled = true;
				if(!window.chrome||this.badge)
				{
					this.updateButton(this.defaultButton);
				}
				if(this.badge)
				{
					this.updateBadge();
				}
			}
			this.clearedCallback();
		}
	};

	/* 現在のフォーカスを登録 */

	WHO.background.prototype.setFocused = function(port,message)
	{
		if(!this.focusedIsLock && this.focused.source != port.source && this.originReg.test(port.url))
		{
			var origin = port.url.match(this.originReg)[0];
			this.focused =
			{
				source      : port.source,
				tab         : port.tab,
				url         : port.url,
				origin      : origin,
				status      : {},
				postMessage : port.postMessage
			};
			if(this.button)
			{
				this.button.disabled = false;
				if(WHO.extension.isChrome)
				{
					this.toggleButton();
				}
				if(this.badge)
				{
					this.updateBadge({display:"block"});
				}
			}
			this.focusedCallback(message);
		}
	};

	//------------------------------------------------------------------------------------//
	/* 現在のフォーカスをロック */

	WHO.background.prototype.lockFocused = function()
	{
		this.focusedIsLock = true;
	};

	/* 現在のフォーカスをアンロック */

	WHO.background.prototype.unlockFocused = function()
	{
		this.focusedIsLock = false;
	};

	//------------------------------------------------------------------------------------//
	/*  */

	WHO.background.prototype.getOrigin = function(url)
	{
		if(this.originReg.test(url))
		{
			var origin = url.match(this.originReg)[0];
			return origin;
		}
		else
		{
			return "";
		}
	};

	/**************************************************************************************/
