/****************************************************************************************************/
/* Opera/Chrome/Safari Extension ラッパー                                                           */
/*      Copyright (c) 2012 by FAR/RAKUDA All Rights Reserved                                        */
/*      Original Namespace : LinkRedirector                                                         */
/****************************************************************************************************/

var WHO = WHO || {};

	/**************************************************************************************/

	WHO.extension = WHO.extension || {};
	WHO.extension.isBackground = true;

	//------------------------------------------------------------------------------------//
	/* ポップアップのサイズを調整 */

	//background 側
	WHO.extension.setPopupSize = function(width,height)
	{
		WHO.extension.popupSize =
		{
			width : width,
			height: height
		};
	};

	/**************************************************************************************/

	/*  #####  #####  ###### #####    ###   */
	/* #     # #    # #      #    #  #   #  */
	/* #     # #    # #      #    # #     # */
	/* #     # #    # #####  #    # ####### */
	/* #     # #####  #      #####  #     # */
	/* #     # #      #      #  #   #     # */
	/*  #####  #      ###### #   ## #     # */

	if(window.opera)
	{
		WHO.extension.isOpera = true;

		//------------------------------------------------------------------------------------//
		/* ストレージ */

		WHO.extension.storage = widget.preferences;

		//------------------------------------------------------------------------------------//
		/* タブがアクティブなタブかどうか */

		WHO.extension.isFocusedTab = function(tab)
		{
			var focusedTab = opera.extension.tabs.getFocused();
			return (focusedTab && tab.url == focusedTab.url);
		};

		/**************************************************************************************/

		//------------------------------------------------------------------------------------//
		/* メッセージ受信 */
		// Backgroud, popup 共有

		WHO.extension.addMessageListener = function(type,listener)
		{
			listener.messageListener = listener.messageListener||{};
			//同じ type に同じ listener は重複して登録しない
			if(listener.messageListener[type])
			{
				return;
			}
			listener.messageListener[type] = function(e)
			{
				var data = e.data;

				if(data.messageType == "message" && data.type == type)
				{
					var connection =
					{
						source      : e.source,
						tab         : {url:e.origin},//Opera では接続ポートからタブを取得できない,
						url         : e.origin,
						postMessage : function(type,message)
						{
						//	try
						//	{
								e.source.postMessage(
								{
									messageType:"message",
									type       :type,
									message    :message
								});
						//	}
						//	catch(e)
						//	{
						//		console.log(e.text);
						//	}
						}
					};

					listener(connection,data.message);
				}
			};
			opera.extension.addEventListener('message',listener.messageListener[type],false);
		};

		/* メッセージ受信を削除 */

		WHO.extension.removeMessageListener = function(type,listener)
		{
			listener.messageListener = listener.messageListener||{};
			opera.extension.removeEventListener('message',listener.messageListener[type],false);
			delete listener.connectListener[type];
		};

		//------------------------------------------------------------------------------------//
		/* リクエスト受信 */
		// background で使用
		// listener : メッセージ受信リスナー
		// listener に渡す引数 :
		//	sender         :
		//	{
		// 		tab            :タブオブジェクト
		//		source         :メッセージ送信先のポート,
		//		url            :メッセージ送信先の URL,
		//		messageCallback:メッセージ送信先からのリクエストコールバック,
		//	},
		//	message        :受信メッセージデータ,

		WHO.extension.addRequestListener = function(type,listener)
		{
			listener.requestListener = listener.requestListener||{};
			if(listener.requestListener[type])
			{
				return;
			}
			listener.requestListener[type] = function(e)
			{
				var data = e.data;

				if(data.messageType == "request" && data.type == type)
				{
					var sender =
					{
						source          : e.source,
						tab             : {url:e.origin},//Opera では接続ポートからタブを取得できない
						url             : e.origin,
						disconnected    : false,
						messageCallback : function(){}
					};

					//requestID が有る時だけコールバックを実行
					if(data.requestID)
					{
						/* コールバックが変える前に接続が切れた時の処理 */
						var disconnect = function(e)
						{
							if(e.source == sender.source)
							{
								opera.extension.removeEventListener('disconnect',disconnect,false);
								sender.disconnected = true;
							}
						};
						opera.extension.addEventListener('disconnect',disconnect,false);

						sender.messageCallback = function(message)
						{
							if(!sender.disconnected)
							{
								opera.extension.removeEventListener('disconnect',disconnect,false);
								e.source.postMessage(
								{
									messageType:"response",
									type       : data.type,
									responseID : data.requestID,
									message    : message
								});
							}
							delete sender.messageCallback;//不要になったコールバックは delete
						};
					}

					listener(sender,data.message);
				}
			};
			opera.extension.addEventListener('message',listener.requestListener[type],false);
		};

		/* リクエスト受信を削除 */

		WHO.extension.removeRequestListener = function(type,listener)
		{
			listener.requestListener = listener.requestListener||{};
			opera.extension.removeEventListener('message',listener.requestListener[type],false);
			delete listener.requestListener[type];
		};

		//------------------------------------------------------------------------------------//
		/* Tab へ単発メッセージ */

//		WHO.extension.postMessageToContent = function(source,type,message)
//		{
//			source.postMessage({messageType:"message",type:type,message:message});
//		};

		/**************************************************************************************/

	}
	else

	/**************************************************************************************/

	/*  #####  #     # #####   #####  #     # ######  */
	/* #     # #     # #    # #     # ##   ## #       */
	/* #       #     # #    # #     # # # # # #       */
	/* #       ####### #    # #     # #  #  # #####   */
	/* #       #     # #####  #     # #     # #       */
	/* #     # #     # #  #   #     # #     # #       */
	/*  #####  #     # #   ##  #####  #     # ######  */

	if(window.chrome)
	{
		WHO.extension.isChrome = true;

		//------------------------------------------------------------------------------------//
		/* ストレージ */

		WHO.extension.storage = window.localStorage;

		/**************************************************************************************/

		//------------------------------------------------------------------------------------//
		/* タブがアクティブなタブかどうか */

		WHO.extension.isFocusedTab = function(tab)
		{
			return (tab && tab.selected);
		};

		/**************************************************************************************/

		//------------------------------------------------------------------------------------//
		/* メッセージ受信 */

		WHO.extension.addMessageListener = function(type,listener)
		{
			listener.connectListener = listener.connectListener||{};
			if(listener.connectListener[type])
			{
				return;
			}
			listener.connectListener[type] = function(port)
			{
				if(port.name == "connect")
				{
					var connection   =
					{
						source      : port,
						tab         : port.sender.tab,
						url         : port.sender.tab ? port.sender.tab.url : "",
						postMessage : function(type,message)
						{
							port.postMessage({type:type,message:message});
						}
					};

					var messageListener = function(data)
					{
						if(data.type == type)
						{
							listener(connection,data.message);
						}
					};

					port.onMessage.addListener(messageListener);
					//接続先がアンロードされた時
					port.onDisconnect.addListener(function()
					{
						port.onDisconnect.removeListener(arguments.callee);
						port.onMessage.removeListener(messageListener);
					});
				}
			};
			chrome.extension.onConnect.addListener(listener.connectListener[type]);
		};

		/* メッセージ受信を削除 */

		WHO.extension.removeMessageListener = function(type,listener)
		{
			listener.connectListener = listener.connectListener||{};
			chrome.extension.onConnect.removeListener(listener.connectListener[type]);
			delete listener.connectListener[type];
		};


		//------------------------------------------------------------------------------------//
		/* リクエスト受信 */

		WHO.extension.addRequestListener = function(type,listener)
		{
			listener.requestListener = listener.requestListener||{};
			if(listener.requestListener[type])
			{
				return;
			}
			listener.requestListener[type] = function(data,source,messageCallback)
			{
				if(data.type == type)
				{
					var sender =
					{
						source          : source,//後方互換
						tab             : source.tab,
						url             : source.tab ? source.tab.url : "",
						messageCallback : messageCallback
					}

					listener(sender,data.message);
				}
			};
			chrome.extension.onRequest.addListener(listener.requestListener[type]);
		};

		/* リクエスト受信を削除 */

		WHO.extension.removeRequestListener = function(type,listener)
		{
			listener.requestListener = listener.requestListener||{};
			chrome.extension.onRequest.removeListener(listener.requestListener[type]);
			delete listener.requestListener[type];
		};
		//------------------------------------------------------------------------------------//
		/* 外部 Extension からの の単発メッセージ受信 */
		// Chrome 専用

		WHO.extension.addExternalRequestListener = function(type,listener)
		{
			listener.externalRequestListener = listener.externalRequestListener||{};
			if(listener.externalRequestListener[type])
			{
				return;
			}
			listener.externalRequestListener[type] = function(data,source,messageCallback)
			{
				if(data.type == type)
				{
					var sender =
					{
						source          : source,//後方互換
						tab             : source.tab,
						url             : source.tab ? source.tab.url : "",
						messageCallback : messageCallback
					}

					listener(sender,data.message);
				}
			};
			chrome.extension.onRequestExternal.addListener(listener.externalRequestListener[type]);
		};

		/* 外部 Extension からの の単発メッセージ受信を削除 */

		WHO.extension.removeExternalRequestListener = function(type,listener)
		{
			listener.externalRequestListener = listener.externalRequestListener||{};
			chrome.extension.onRequest.removeListener(listener.externalRequestListener[type]);
			delete listener.externalRequestListener[type];
		};

	//	//------------------------------------------------------------------------------------//
	//	/* Tab へ単発メッセージ */
	//	// エラーチェックしてない
    //
	//	WHO.extension.postMessageToContent = function(tab,type,message)
	//	{
	//		chrome.tabs.sendRequest(tab.id,{type:type,message:message});
	//	};

		/*******************************************************************************/
	}
	else

	/**************************************************************************************/

	/*  #####    ###   ######   ###   #####  ### */
	/* #     #  #   #  #       #   #  #    #  #  */
	/* #       #     # #      #     # #    #  #  */
	/*  #####  ####### #####  ####### #    #  #  */
	/*       # #     # #      #     # #####   #  */
	/* #     # #     # #      #     # #  #    #  */
	/*  #####  #     # #      #     # #   ## ### */

	if(window.safari)
	{
		WHO.extension.isSafari = true;

		//------------------------------------------------------------------------------------//
		/* ストレージ */

		WHO.extension.storage = window.localStorage;

		// Options で保存されたデータをコピー
		safari.application.addEventListener('message',
		function(e)
		{
			var data = e.message;
			if(e.name == "localStorage")
			{
				if(data.method == "setItem")
				{
					window.localStorage.setItem(data.key,data.value);
				}
				else
				if(data.method == "removeItem")
				{
					window.localStorage.removeItem(data.key);
				}
			}
		},false);

		//------------------------------------------------------------------------------------//
		/* タブがアクティブなタブかどうか */

		WHO.extension.isFocusedTab = function(tab)
		{
			var focusedTab = safari.application.activeBrowserWindow.activeTab;
			return (focusedTab && tab == focusedTab);
		};

		/**************************************************************************************/

		//------------------------------------------------------------------------------------//
		/* メッセージ受信 */

		WHO.extension.addMessageListener = function(type,listener)
		{

			// Popup -> Background
			listener.popupMessageListener = listener.popupMessageListener||{};
			if(!listener.popupMessageListener[type])
			{
				listener.popupMessageListener[type] = function(e)
				{
					var data = e.data;

					if(data.messageType == "message" && data.type == type)
					{
						var connection   =
						{
							source      : e.source,
							tab         : {url:e.origin},
							url         : e.origin,
							postMessage : function(type,message)
							{
								connection.source.postMessage(
								{
									messageType:"message",
									type       :type,
									message    :message
								},e.origin);
							}
						};

						listener(connection,data.message);
					}
				};
				window.addEventListener('message',listener.popupMessageListener[type],false)
			}

			// Content, Options -> Background
			listener.messageListener = listener.messageListener||{};
			if(!listener.messageListener[type])
			{
				listener.messageListener[type] = function(e)
				{
					var data   = e.message;

					if(e.name == "message" && data.type == type && e.target.page)
					{
						var connection   =
						{
							source      : e.target.page,
							tab         : e.target,
							url         : e.target.url,
							postMessage : function(type,message)
							{
								//タブに含まれる全てのページに送られる
								e.target.page.dispatchMessage('message',
								{
									type    :type,
									pageID  :data.pageID,
									message :message
								});
							}
						};

						listener(connection,data.message);
					}
				};
				safari.application.addEventListener('message',listener.messageListener[type],false);
			}

		};

		/* メッセージ受信を削除 */

		WHO.extension.removeMessageListener = function(type,listener)
		{
			listener.messageListener = listener.messageListener||{};
			safari.application.removeEventListener('message',listener.messageListener[type],false);
			delete listener.messageListener[type];

			listener.popupMessageListener = listener.popupMessageListener||{};
			window.removeEventListener('message',listener.popupMessageListener[type],false)
			delete listener.popupMessageListener[type];
		};

		//------------------------------------------------------------------------------------//
		/* リクエスト受信 */

		WHO.extension.addRequestListener = function(type,listener)
		{

			// Popup -> Background
			listener.popupRequestListener = listener.popupRequestListener||{};
			if(!listener.popupRequestListener[type])
			{
				listener.popupRequestListener[type] = function(e)
				{
					var data = e.data;

					if(data.messageType == "request" && data.type == type)
					{
						var sender =
						{
							source          : e.source,
							tab             : {url:e.origin},
							url             : e.origin,
							messageCallback : function(){}
						};

						if(data.requestID)
						{
							sender.messageCallback = function(message)
							{
								sender.source.postMessage(
								{
									messageType:"response",
									type       :data.type,
									responseID :data.requestID,
									message    :message
								},"*");
								delete sender.messageCallback;
							};
						}

						listener(sender,data.message);
					}
				}
				window.addEventListener('message',listener.popupRequestListener[type],false);
			}

			// Contents, Options -> Bacground
			listener.requestListener = listener.requestListener||{};
			if(!listener.requestListener[type])
			{
				listener.requestListener[type] = function(e)
				{
					var data   = e.message;

					if(e.name == "request" && data.type == type)
					{
						var sender =
						{
							source          : e.target.page,
							tab             : e.target,
							url             : e.target.url,
							messageCallback : function(){}
						}
						// Safari では about:blank でも Content Script が fire する
						if(data.requestID && e.target.page)
						{
							sender.messageCallback = function(message)
							{
								//tab に含まれる全てのページに送られる
								e.target.page.dispatchMessage("response",
								{
									type      :data.type,
									pageID    :data.pageID,
									responseID:data.requestID,
									message   :message
								});
								delete sender.messageCallback;
							};
						}

						listener(sender,data.message);
					}
				};
				safari.application.addEventListener('message',listener.requestListener[type],false);
			}

		};

		/* リクエスト受信を削除 */

		WHO.extension.removeRequestListener = function(type,listener)
		{
			listener.requestListener = listener.requestListener||{};
			safari.application.removeEventListener('message',listener.requestListener[type],false);
			delete listener.requestListener[type];

			listener.popupRequestListener = listener.popupRequestListener||{};
			window.removeEventListener('message',listener.popupRequestListener[type],false);
			delete istener.popupRequestListener[type];
		};

	//	//------------------------------------------------------------------------------------//
	//	/* Tab へ単発メッセージ */
    //
	//	WHO.extension.postMessageToContent = function(tab,type,message)
	//	{
	//		tab.dispatchMessage("message",{type:type,message:message});
	//	};

		/**************************************************************************************/
	}

