function background()
{

	var storage = WHO.extension.storage;

	/**************************************************************************************/
	/* UI 生成 */

	var UI = new WHO.background(
	{
		'extensionName' : "QuaBEx",

		'originType'    : "protocol",//full,page,port,protocol,domain

		'button'        :
		{
			'title'     : "QuaBEx",
			'icon'      : "icons/disabled.png"
		},
		'popup'         :
		{
			href  :"popup.html",//Opera, Firefox のみ有効。 Chrome, Safari は定義ファイルで設定。
			width : 200,
			height: 364,
		},
		focusedCallback : function(message)
		{
			changeIcon(UI.focused.origin);
		},
	});

	//------------------------------------------------------------------------------------//
	/* 通信ポート開放 */

	WHO.extension.addRequestListener('QuaBEx',function(sender,message)
	{
		//アイコンを変更（有効無効を切り替え）
		if(message.method == "changeIcon")
		{
			changeIcon(UI.focused.origin);
		}
		else
		{
			var origin  = UI.getOrigin(sender.url);

			//設定を取得する

			if(message.method == "getPrefs")
			{
				sender.messageCallback({method:"setPrefs",prefs:getPrefs(origin)});
			}
		}
	});

	/**************************************************************************************/

	//------------------------------------------------------------------------------------//
	//アイコンの切り替え

	function changeIcon(origin)
	{
		var isDisabled = getSitePrefs(origin)["disabled"];
		if(isDisabled)
		{
			UI.updateButton(
			{
				icon  : "icons/disabled.png",
				title : origin
			});
		}
		else
		{
			UI.updateButton(
			{
				icon  : "icons/enabled.png",
				title : origin
			});
		}
	}

	//------------------------------------------------------------------------------------//
	/* サイト別設定取得 */

	function getSitePrefs(origin)
	{
		var allSitePrefs = JSON.parse(storage.getItem('allSitePrefs')) || {};
		return allSitePrefs[origin]||{};
	}

	/* 設定取得 */

	function getPrefs(origin)
	{
		var sitePrefs = getSitePrefs(origin);
		var prefs =
		{
			behavior : JSON.parse(storage.getItem('behavior'))||{test:false},
			disabled : sitePrefs["disabled"],
		};

		return prefs;
	}

	/**************************************************************************************/
}
