/* モジュールのロード */
const SELF    = require("self");
const DATA    = require("self").data;
const MOD     = require("page-mod");
/* 多言語化 */
const LOCALE  = require("preferences-service").get("general.useragent.locale");

//const WIDGET  = require("widget");
//const PANEL   = require("panel");
//const TABS    = require("tabs");
//const STORAGE = require("simple-storage").storage;
//const WORKER       = require("page-worker");
//const contextMenu = require("context-menu");
//const url = require("url");

// setTimeout を使う時
//const TIMERS  = require("timers");
//const setTimeout     = TIMERS.setTimeout;
//const clearTimeout   = TIMERS.clearTimeout;

// XMLHttpRequest を使う時
//const XMLHttpRequest = require("xhr").XMLHttpRequest;



/* メイン */
exports.main = function()
{
	var WHO = {};

	/* 言語設定 */
	// Opera の locales フォルダの構造をそのまま書く
	var LOCALES =
	{
		"default":
		{
			"preferences/lang.js"   :"preferences/lang.js",
		},
		"ja":
		{
			"preferences/lang.js"   :"locales/ja/preferences/lang.js",
		},
		"en":
		{
			"preferences/lang.js"   :"locales/en/preferences/lang.js",
		},
	};
	var LOCALEFILES = LOCALES[LOCALE]||LOCALES["default"];

	/* Background Script Files */
	//実行順に注意
	//裸のスクリプトは出来るだけ書かずに関数化する事
	// eval でエラーが出るものは Jetpack module 化して require でロード

	eval(DATA.load(LOCALEFILES["preferences/lang.js"]));
	eval(DATA.load("scripts/background.js"));

	/* 必須ライブラリ */

	WHO.extension  = require("WHO.extension").extension;
	WHO.background = require("WHO.background").background;
	WHO.extension.setLocaleFiles(LOCALEFILES);

	/* Content Scripts */
	//ページ毎に実行するスクリプト。
	//PageMod 毎にコンテキストが異なるので、 jetpack.extension.js は PageMod 毎に必須。

	var page = MOD.PageMod(
	{
		include          :["http://*","https://*"],
		contentScriptWhen: "ready",
		contentScriptFile:
		[
			DATA.url("includes/0.extension.js"),//必須

			// ==UserScript==

			DATA.url("includes/test.js"),
			DATA.url("includes/WHO.focused.js"),//ページ毎にボタンを切り替える時に必要

			// ==/UserScript==

		],
		onAttach : WHO.extension.onAttach
	});

	/* Background Script */
	// Background Script Files でロードした関数を実行する。

	background();

};
